ANET.at HomepageSearchEngine
History

______________________________
Chronology of version releases


 Date      	Version
 ----------	------------

 2003 06 10	3.42
 2003 03 27	3.41
 2003 01 30	3.4+

 2002 09 24	3.4
 2002 06 03	3.37
 2002 01 30	3.36

 2001 12 06	3.35
 2001 11 04	3.34
 2001 10 23	3.33
 2001 07 04	3.32
 2001 05 27	3.31
 2001 03 29	3.3
 2001 02 01	3.21

 2000 12 14	3.2
 2000 10 27	3.1
 2000 09 03	3.03
 2000 08 08	3.02
 2000 07 17	3.01
 2000 06 18	3.0
 2000 03 05	2.07
 2000 01 31	2.06
 2000 01 18	2.05
 2000 01 10	2.04a

 1999 12 27	2.04
 1999 10 25	2.03
 1999 10 04	2.02
 1999 09 27	2.01
 1999 09 14	2.0
 1999 09 06	1.01
 1999 08 02	1.0


_________________________________________
History of version changes ("change log")


 v3.42 (June 10, 2003) (What's new)
 ----------------------------------

 + File-list files are now sorted by date of last modification, to ensure the latest modified files to be searched first.
   The sorting method can be changed by the new "-sort=date|name|none" option of the "makelist" command.
 + Incremental indexing (using the "index" command's new "-part=PART[/TOTALPARTS]" option) allows to index a large amount
   of files via the web based console, which would probably fail when tried to index in one step.
 + "Autocomplete indexing" feature allows easy index creation using the web based Admin Area, with just one click. All
   required actions will be performed automatically, such as switching to incremental indexing if necesarry.
 + the style of the icon printed before each result can be customized via the Style Sheet (using the ".HSE-icon" definition)
 + When the search source for an indexed search will be listed (by searching for "list:files"), the day of last modification
   of each file is printed (in addition to its URL and file size). This makes it possible to easily ensure if the file-list
   has been sorted by date of last modification.
 + When the search source for an on-the-fly search will be listed (by searching for "list:files"), the files appear in the
   order the real search takes place. That list can be displayed in alphabetical order instead by selecting "the path name"
   from the "Show ... hits ... sorted by" drop down menu of the pre-built input form.
 + all commands can be used with the "-debug" option, to enable verbose mode
 + HTML files will not be searched and indexed if they contain a "robots" meta tag with the content "noindex" or "none"
   (unless it contains "search"). These skipped files can be viewed when the "index" command is used with the "-debug" option.
 + improved Admin Area (with a Session ID based, server-sided User authentification system)
 + character set for Czech (language code "cs") changed from "iso-8859-2" to "windows-1250"


 v3.41 (March 27, 2003)
 ----------------------

 + Spider improvements:
	+ supports the /robots.txt Robots Exclusion Protocol (with "HomepageSearchEngine" as the robot name)
	+ supports "robots" meta tags (content="noindex, nofollow, none")
	+ "-noquerystrings" option added to cut query strings from links
	+ directory URLs will only be recognized once, regardless if they have a trailing slash or not
	+ works also without an hse.ini file
 + added "-prefix" option for the "changeurls" command to directly set the local start URL to be prefixed
 + to be more flexible, the strings in the "ban_list", "search_always" and "categories_sourceNR" directives are now *not*
   wildcarded at the beginning and at the end. To do so, the "*" wildcard symbol must be added at the desired positions.
 + ASP (Active Server Page) pages are also recognized with the .aspx extension (as created by ASP.NET)
 + when a required shared object is missing, the error message should point to the object in question instead of just
   printing an "Unknown error"
 + the design of results output has been changed slightly to be similar to that currently known from Google and AltaVista
 + the Free version (formerly Light edition) is now more configurable (see http://free.HomepageSearchEngine.com)


 v3.4+ (January 30, 2003)
 ------------------------

 + libraries replaced by newer versions in order to support new UTF-8 related features
 + a custom input form that preserves the previous form settings now also restores Japanese terms properly using IE and Opera
 + automatic determination of the CGI executable's URL now also works properly on special Apache environments (eg. with sbox)
 + language code for Japanese changed from mistakenly used "jp" to correct ISO 639-1 code "ja"
 + problem solved that may have occured when trying to access the admin area via the https protocol
 + added IANA character set information to each "WhatsThis.txt" file residing in the language directories
 + if platform detection by the shell script ("platform.cgi") fails, the Perl script "platform.pl" should do its job
 + shell commands "changetitles" and "memory" removed
 + discontinued support for the platform GNU/Linux-mips


 v3.4 (September 24, 2002)
 -------------------------

 + flat (file-list based) search method introduced which combines a semi-on-the-fly and a semi-indexed search method
 + indexing process splitted into two steps in order to consume less resources in each process: 
   making of the file-list (by the new "makelist" command) and creating of the index files (by the "index" command)
 + shell command "spider" added to spider an entire site and make the URL-list file to grab URLs automatically
 + Unicode support for all ASCII and Latin-1 characters, in both hexadecimal and decimal notations
 + alternative "locale-enabled" HSE executable added that supports the new "locale" configuration directive
   to solve the "always-case-sensitive" bug affecting Non-US-ASCII characters on English based systems
 + added "title (T)" key word for the "results_details" configuration directive to disable or customize printing of the
   title of a web page before each listing of a found file on the results page
 + added "maxsize:SIZE" key word for the "results_href" configuration directive to automatically disable the 
   highlightmatches/gotofirstmatch feature on target files with a size higher than specified, in order to save memory
 + Extensible Markup Language (XML) files (.xml) are recognized as web pages
 + Wireless Markup Language (WML) files (.wml) are recognized as web pages
 + enhanced support for named entities: now 101 forms are supported, including the ones for:
	+ all the 96 Latin-1 characters
	+ the HTML ASCII characters (", &, < and >) and the Euro sign (€)
 + '&' in URLs to be printed will be converted into the entity to prevent strings to be interpreted as entities
 + fixed bug regarding '&lt;' and '&gt;' in titles
 + fixed bug regarding highlighting of more than one search terms in the "Google-like" style of the results' descriptions
 + improvements when the highlightmatches feature is turned on to highlight the matches in the result files:
	+ a newline that separates two words of a matching phrase will be ignored
	+ newlines within a <pre>...</pre> section will *not* be ignored
	+ documents with the text/xml MIME type will be printed directly by the browser (and not parsed through HSE)
 + all '&nbsp;' named entities replaced by its Unicode equivalent ('&#160;') in order to be XML compliant
 + all '@' characters replaced by its Unicode equivalent ('&#64;') to make eMail addresses harder to find by span robots
 + Helper Application Perl CGI script "passurl.cgi" included to redirect the result URLs to a custom application
 + new cronjob scripts ("hse_cronjob.sh" and "hse_cronjob.bat") included
 + "hse_customform.js" JavaScript library now works properly with Mozilla 1+ and Opera 6+
 + the included special URL-list example file "hse_urllist2.csv" is now more format tolerant
 + in the FreeBSD package, a wrapper script has been added to achieve compatibility with all FreeBSD 4.x installations
 + when the "lang" delivery parameter is set to "de", the mouseover titles on the pre-built input form are printed in German
 + character set for Thai (language code "th") changed from "windows-874" to "tis-620"
 + language code for simplified Chinese (Chinese/China) changed from "zh" to "zh-cn"


 v3.37 (June 3, 2002)
 --------------------

 + added "icon:default|custom16x16|custom" key words for the "results_details" configuration directive to show an icon image
   before each result
 + the "sort" parameter can now also be "name" to sort the search results by the name of the file path
 + the value of an "append" delivery parameter will be appended to the result URLs in order to support dynamic shopping carts
 + HTML sections to be excluded from being searched can now also be spanned using the <div> tag instead of <span>
 + on the results page, each listing of a found file is now anchored (with the name of its number)
 + a "debug_level" of "2" now avoids unsecure access of the admin area; a value of "3" also disables printing of the file list
 + a stand alone asterik character ("*") as search term will no more be treated as wildcard
 + the pre-built advanced input form contains images
 + the file list prints all files with their associated icon images
 + updated language files
 + deprecated names "HomepageSearchEngine..." for all the config files are no longer supported, so only "hse..." will work 


 v3.36 (January 30, 2002)
 ------------------------

 + CGI application can also be used as "URL inspector":
	 + to highlight all matches in any HTTP URL's content, supporting one or more search terms
	 + to inspect any HTTP URL's header informations responded by the webserver
 + HTML version used for all output to the browser updated from HTML 4.01 Transitional to XHTML 1.0 Transitional
 + in the results list, the number of matches from each file is also given for each term separately
 + added configuration directive "allowed_referer_sites" to restrict sites that may call the CGI application
 + a "debug_level" of "1" now prevents pathes to be printed to the browser in all messages
 + added sample HTML template containing a custom input form including JavaScript code to preserve the previous form settings
 + SSI and PHP templates now contain a custom input form including "URL Inspector" and preserving the previous form settings
 + configuration directive "results_descriptions" also allows to set how many characters surround the match of a list item
 + added additional library for Win32 to solve problems when a username and password is given to the baseurl
 + deprecated key name "hse.key" is no longer supported, so now only "hse_key.cgi" will work


 v3.35 (December 6, 2001)
 ------------------------

 + when the first match is part of a link, the "gotofirstmatch" feature now does not break the link anymore
 + when viewing a results page with the "highlightmatches" feature, a window pops up if no hit is in that page's body
 + support of finding characters as entities re-enabled (was broken since v3.33)
 + to minimize problems on MacOS and with Non-Unix users, all shipped configuration files begin with "hse" instead of
   "HomepageSearchEngine" in order to be not more than 31 characters long and in all lowercase
 + new directive "cgiurl" can be used if the SCRIPT_NAME environment variable is not set properly in some rare cases
 + the "results_previous_img" and "results_next_img" directives now default to specify a built-in image set
 + added "matches" key word for the "results_details" directive to be able to prevent printing the number of matches
 + Netscape 4 issue on non iso-8859-1 character sets solved
 + language support for Romanian


 v3.34 (November 4, 2001)
 ------------------------

 + added "gotofirstmatch" key word for the "results_href" directive to locate matches within the found pages even easier
 + the "results_href" directive now defaults to "highlightmatches + gotofirstmatch"
 + searches with wildcards within search terms are now possible (by applying the "*" wildcard character)
 + added configuration directive "exclude_dirs" to prevent directories from ever being looked into
 + the "*" wildcard character can be used for all configuration directives that specify file sources
   (exclude_dirs, ban_list, search_always and categories_sourceNR)
 + searching for "list:files" prints additional useful information, to improve the configuration for on-the-fly searches
 + updated language help files to reflect the possibility to use wildcards
 + language support for Japanese
 + improved highlighting method avoids problems with Japanese or any other non Latin characters


 v3.33 (October 23, 2001)
 ------------------------

 + added "-nononhtml" and "-nohtml" options for the "index" command to enable faster index processes
 + additional syntax to be used in the URL-list file to enable searching different complete websites as different categories
 + dynamic progress bars now work with the browsers Internet Explorer 4+, all Gecko based browsers including Netscape 6+
   (enabled by default) and optionally Netscape 4 and Opera 4+ (disabled by default)
 + progress bar now also appears while determining search source for creating the file list (by searching for "list:files")
 + text corresponding to the progress bars is in the proper language
 + delivery parameter "case" changed to "matchcase" to avoid problems with custom JavaScript
 + enhanced search routine for RichTextFormat documents
 + URL values of configuration directives (baseurl and template_url) beginning with "/" now also work with ports other than 80
 + Help Window now also works with Opera browsers
 + distributed packages have a new, more intuitive directory structure
 + Apple MacOS X platform is supported


 v3.32 (July 4, 2001)
 --------------------

 + index format changed from character separated .csv to tabstop separated .txt files 
 + terms containing the "|" character can now be searched which enables full support for Big5 character sets (zh-tw)
 + results contain only design-neutral HTML tags with class identifiers which enhances StyleSheet support
 + redesigned list that contains the links to further results pages
 + sections within HTML files can be spanned to be excluded from being searched
 + added configuration directive "debug_level" to control debugging output
 + added configuration directive "max_found_files" to control maximal number of foundable files
 + added configuration directive "cgi_timeout" to control maximal CPU time the CGI application may require
 + more options for the configuration directive "results_global" 
 + dynamic progress bars added to show the current status of the search
 + password protected directories can now be searched without the need to turn off the 'highlightmatches' feature
 + the value of the "lang" delivery parameter will also be sent to the server as accepted language (HTTP_ACCEPT_LANGUAGE)
 + added "-lang" option for the "geturls" command for sending its value to the server as accepted language
 + the result links for viewing the found files with highlighted matches are now in the proper format 
   (the QUERY_STRING is application/x-www-form-urlencoded)
 + separator between CGI arguments changed from '&' to ';' to meet W3C compliant valid HTML 4.01
 + the default HTML templates now include a button to verify that the document is made of 100% valid HTML 4.01
 + when trying a search without a term the user will be prompted for the missing input instead of doing nothing
 + the Shell Executable commands now also print date and time of their actions to their log
 + now includes cron job script files for both Unix ("cronjob.sh") and Windows ("cronjob.bat") including a detailed How-To
 + language support for Norwegian and Thai


 v3.31 (May 27, 2001)
 --------------------

 + redesigned source code structure to consume less system's resources
 + memory consumption of the Shell executable can be determined (by the "memory" command)
 + added "-cat" and "-nocheck" options for the "index" command
 + CGI application can be run in debug mode for easier troubleshooting
 + viewing files with highlighted matches now also work with Non-HTML files
 + querying the search string to a world wide search engine out from the input form now opens a new window
 + MIVA Script files (.mv) are recognized as web pages
 + for improved security, the key file can (alternatively) be named "HomepageSearchEngine_key.cgi"
 + Swedish language help file added


 v3.3 (March 29, 2001)
 ---------------------

 + found files can be viewed with all matches highlighted (highlightmatches feature)
 + highlighting of matches can now be done using any desired style
 + support of dynamic HTML templates (using any script language supported by the server) 
 + the search string can now be queried to 11 world wide search engines (including German ones)
 + the restrictive search options ("Match case"  and "Find only whole words") are now set off by default
 + the configuration (.ini) file(s) can now be saved in each DOS, Unix or Mac format
 + Arabic and Finnish language help files added
 + an internal server error on some BSD/OS systems can now be solved by calling the executable on the shell once


 v3.21 (February 1, 2001)
 ------------------------

 + customization of results page(s) is now more configurable 
   (handled by the directives "results_global" and "results_details")
 + changeurls functionality is now also available for on-the-fly searches
 + Sun's JavaServer Pages files (.jsp) are recognized as web pages
 + smaller library files
 + all configuration files can now have a short name alternatively (beginning with "hse" instead of "HomepageSearchEngine")
 + language support for Finnish and (Latin) Serbian
 + NetBSD platform is supported
 + some Portable Network Graphics images added
 + fixed bug: values of advanced search options may have been lost when the advanced search box was switched off


 v3.2 (December 14, 2000)
 ------------------------

 + indexed search in large websites performs now approx. twice as fast
 + the executable file has been splitted into a smaller one and some libraries
 + each index file "HomepageSearchEngine_indexX.csv" has been splitted into an index file pair of
   "HomepageSearchEngine_indexX_html.csv" and "HomepageSearchEngine_indexX_nonhtml.csv"
 + the template files "HomepageSearchEngine_header.txt" and "HomepageSearchEngine_footer.txt" have been merged into one file
   called "HomepageSearchEngine_template.html" 
 + improved Shell Executable handling
 + language support for Hungarian and Italian


 v3.1 (October 27, 2000)
 -----------------------

 + shell command "geturls" added that allows to grab any URLs making them searchable on your site
 + improved descriptions shown for each hit: the configuration directive "results_descriptions" allows 
   "AltaVista style" or/and "Google style" output with specified quantities
 + AltaVista.com or Google.com can be queried via links on the results list in addition to out from the input form
 + added configuration directives "results_previous_img" and "results_next_img" to use images alternatively to 
   "[ << previous ]" and "[ next >> ]" in the link list to other results on the bottom of each result page
 + Allaire's ColdFusion Markup Language files (.cfm) are recognized as web pages
 + handling of the Admin Console is more user-friendly and secure
 + name of the users file renamed to "HomepageSearchEngine_users.cgi" to improve security on badly configured webservers
 + revalorization of the Light edition: phrases and logical operators are now available in all version types
 + updated language help files
 + language support for Greek and Polish


 v3.03 (September 3, 2000)
 -------------------------

 + shell commands "changetitles" and "changeurls" added for modifying the index file(s)
 + Web based Admin Console has been added that allows authentificated users to execute all shell commands enabling them to 
   create and modify the index files using their webbrowser. 
 + the help window headlines' color can be changed (by changing <span style="color:blue"> in "HomepageSearchEngine_help.txt")
 + language support for French
 + fixed bug that affected categories and was caused by some license keys


 v3.02 (August 8, 2000)
 ----------------------

 + the Light edition is now freeware (it can be used completetely free)
 + added possibility not to display an auto generated input form
 + changed the results' links class identifier name to meet the W3C CSS2 recommendation
 + language support for Danish and Swedish


 v3.01 (July 17, 2000)
 ---------------------

 + several different configuration sets can now be used alternatively (by delivering the "conf=DIR" parameter)
 + command prompt options updated to include "-conf=DIR" for creating the index file(s)
 + language support for traditional Chinese, Portuguese and Russian
 + fixed bug that may have occured under IIS regarding the index files
 + fixed bug regarding switching between simple and advanced input form in the default language
 + fixed default international settings for Turkish


 v3.0 (June 18, 2000)
 --------------------

 + now the indexed search method can be applied (in addition to the on-the-fly search method) to speed up search time
 + executable file can also be executed on the command prompt (shell) for creating the index file(s)
 + it can now be switched between all available languages and their associated settings 
   (by delivering the "lang=LANG" parameter)
 + added configuration directive "date_format" to support international date formats
 + added configuration directive "decimal_sep" to support international decimal separators
 + added configuration directive "chars_alignment" to support languages read from right to left (like Arabic)
 + added configuration directives "helpwindow_width" and "helpwindow_height" for adjusting the help window's size
 + added configuration directive "target" for specifying a target frame name where the result URLs should link to
 + added configuration directive "results_href" to parse the result URLs through an external script or program
 + the results' links have been assigned to a specific class to be accessable via StyleSheets
 + all files and directories beginning with "_" or "." are now always in the ban_list
 + better support for IIS webservers (regarding the Windows 32bit platform)
 + re-arranged configuration file ("HomepageSearchEngine.ini")
 + language file splitted in core file for general output ("HomepageSearchEngine_lang.txt") and file for 
   output of the help window content ("HomepageSearchEngine_help.txt") for more flexibility and easier editing
 + language support for Arabic, simplified Chinese, Czech, Dutch and Turkish
 + DEC OSF/1 platform is supported
 + improved licensing mechanism supports multi domain license keys
 + stripping of script code and comments improved
 + distinction between HTML and Non-HTML files now works properly
 + workaround to solve problems with the help window's JavaScript code when using Netscape on Macintosh


 v2.07 (March 5, 2000)
 ---------------------

 + advanced user choosable search option to search Non-HTML text files including RichTextFormat (.rtf) documents added
 + added support for ASP (Active Server Page) pages (with the .asp extension)
 + added configuration directive "formtable_input-size" for outfit customizing of the input form
 + number of possible categories increased to 25
 + input terms will be checked more effective and then sorted before being applied to the search
 + enhanced method for sorting files that are displayed in the results pages
 + search string "list:pages" was generalized to "list:files"
 + language files revised


 v2.06 (January 31, 2000)
 ------------------------

 + added configuration directive "highlight-color" for outfit customizing of results pages
 + input form can be configured to have no background
 + HTML code for the results page adapted to be compatible with Mozilla/5.0 (Netscape 6) pre-release
 + changed licensing mechanism now allows registered users to upgrade their versions by downloading the current free version
 + in the results page(s) now the URL of a file is shown correctly instead of its title when it has no title
 + bug fixed that occured when using "categories_sourceX = engine:altavista" with more than 1 search term


 v2.05 (January 18, 2000)
 ------------------------

 + enhanced categories features
 + possibility to query your search terms to a world wide search engine for searching the whole web
 + configuration file ("HomepageSearchEngine.ini") is easier to survey and more syntax tolerant
 + now there is one package compatible with all GNU/Linux distributions for ix86 processors
 + GNU/Linux-mips platform is supported
 + fixed bug that caused bad performance when searching in some rarely occured files


 v2.04a (January 10, 2000)
 -------------------------

 + now all special characters with corresponding HTML-entities (concerning German, Spanish, Italian, ...) 
   will be found as both direct characters (eg. ä ñ à) and HTML-entities (eg. &auml; &ntilde; &agrave;)
 + OpenBSD platform is supported


 v2.04 (December 27, 1999)
 -------------------------

 + added an editable language file "HomepageSearchEngine_lang.txt" to enable support for all languages.
   Language files for English, German and Spanish included.
 + file naming scheme changed (now all files begin with "HomepageSearchEngine")
 + HTML code for the input form adapted to be compatible under Unix and with Mozilla/5.0 pre-release
 + minor changes in the configuration file and in the program's source code
 + FreeBSD platform is supported
 + IBM AIX platform is supported


 v2.03 (October 25, 1999)
 ------------------------

 + added ability to search in certain categories 
 + added configuration directives "results_details" and "results_show_urls" for outfit customizing of results pages
 + all matches within the informations showed in the results pages are now highligthed.
 + the list of searched pages is now accessable by typing in "list:pages" and lists the pages for the actual category
 + removed splash screen from the Trial version
 + BSDi BSD/OS platform is supported
 + HP HP-UX platform is supported
 + SGI IRIX64 platform is supported


 v2.02 (October 4, 1999)
 -----------------------

 + added configuration directive "charset" for supporting international character sets
 + maximal choosable number of hits to output on results pages increased to 50
 + Sun Solaris platform is supported
 + fixed bug concerning links on results pages when number of hits to output was changed from default value
 + fixed bug: in some cases the "search_always" directive was ignored


 v2.01 (September 27, 1999)
 --------------------------

 + added configuration directives "formtable_border-color" and "formtable_alignment" for outfit customizing of input form
 + the input form defaults to a simple search and can be enhanced to advanced search


 v2.0 (September 14, 1999)
 -------------------------

 + the search string can now include phrases (enclosed between quotes) together with single words
 + each term of the search string can now be marked with the plus- or minus-sign to force or forbid its presence
   in found pages (as you may know from AltaVista)
 + a checkbox was added which automatically mark all signless terms with the plus-sign
 + restrictive search options arranged as a checkbox-group
 + added restrictive search option to find only whole words
 + now you can choose the parts of the web pages to be searched (you can turn on or off each part):
   title, description and keywords, text of the file body and alternative texts of the images
 + it's now possible to search for special characters, too (eg. "C:\boot.ini")
 + online-help integrated in the search form
 + the number of matches of all terms can be shown in the results pages
 + the required time for the search can be shown in the results pages
 + improved output-list of all the files that will be searched
 + configuration file is now shorter and easier
 + face of the text and links in the search form is customizable via StyleSheet


 v1.01 (September 6, 1999)
 -------------------------

 + ranking list can now be sorted by time of the last update, as an alternative to the number of matches
 + Windows 32bit platform is supported


 v1.0 (August 2, 1999)
 ---------------------

 + first public release for GNU/Linux platform
